/* key_type.h */
/*
 * Modified by National Institute of Informatics in Japan, 2014-2019.
 */
/*
 * Copyright (C) 1998-2002
 * Akira Iwata & Takuto Okuno
 * Akira Iwata Laboratory,
 * Nagoya Institute of Technology in Japan.
 *
 * All rights reserved.
 *
 * This software is written by Takuto Okuno(usapato@anet.ne.jp)
 * And if you want to contact us, send an email to Kimitake Wakayama
 * (wakayama@elcom.nitech.ac.jp)
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * 3. All advertising materials mentioning features or use of this software must
 *    display the following acknowledgment:
 *    "This product includes software developed by Akira Iwata Laboratory,
 *    Nagoya Institute of Technology in Japan (http://mars.elcom.nitech.ac.jp/)."
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Akira Iwata Laboratory,
 *     Nagoya Institute of Technology in Japan (http://mars.elcom.nitech.ac.jp/)."
 *
 *   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
 *   AKIRA IWATA LABORATORY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 *   SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 *   IN NO EVENT SHALL AKIRA IWATA LABORATORY BE LIABLE FOR ANY SPECIAL,
 *   INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 *   FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 *   NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION
 *   WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef INCLUSION_GUARD_UUID_871BCBFE_6A53_486A_A774_E86BEDE60EAA
#define INCLUSION_GUARD_UUID_871BCBFE_6A53_486A_A774_E86BEDE60EAA

/* Public Key Type define
   use of struct Cert->pubkey */
#define	KEY_NULL	530

#define	KEY_DES		533
#define KEY_3DES	534
#define KEY_RC2		535
#define KEY_RC4		536
#define KEY_AES		541
#define KEY_CHACHA	542

#define	KEY_RSA_PUB	531
#define	KEY_RSA_PRV	532
#define KEY_DSA_PUB	537
#define KEY_DSA_PRV	538
#define KEY_DH_PUB	539
#define KEY_DH_PRV	540
#define KEY_ECDSA_PUB	550
#define KEY_ECDSA_PRV	551
#define KEY_X25519_PUB	552
#define KEY_X25519_PRV	553
#define KEY_X448_PUB	554
#define KEY_X448_PRV	555

#define	KEY_P11RSA_PUB	561
#define	KEY_P11RSA_PRV	562
#define KEY_P11DSA_PUB	563
#define KEY_P11DSA_PRV	564
#define KEY_P11DH_PUB	565
#define KEY_P11DH_PRV	566
#define KEY_P11ECDSA_PUB	567
#define KEY_P11ECDSA_PRV	568

#endif	/* INCLUSION_GUARD_UUID_871BCBFE_6A53_486A_A774_E86BEDE60EAA */
