/* edctest.c */
/*
 * Copyright (c) 2019 National Institute of Informatics in Japan,
 * All rights reserved.
 *
 * This file or a portion of this file is licensed under the terms of
 * the NAREGI Public License, found at http://www.naregi.org/download/index.html.
 * If you redistribute this file, with or without modifications, you must
 * include this notice in the file.
 */

#include <stdio.h>
#include <stdlib.h>

#include "edctest.h"

int main(void) {
	if (test_X25519_derive() != 0) {
		exit(EXIT_FAILURE);
	}

	if (test_X448_derive() != 0) {
		exit(EXIT_FAILURE);
	}

	if (test_X25519_derive_with_iteration() != 0) {
		exit(EXIT_FAILURE);
	}

	if (test_X448_derive_with_iteration() != 0) {
		exit(EXIT_FAILURE);
	}

	if (test_X25519_Diffie_Hellman() != 0) {
		exit(EXIT_FAILURE);
	}

	if (test_X448_Diffie_Hellman() != 0) {
		exit(EXIT_FAILURE);
	}

	return EXIT_SUCCESS;
}
