/* siggenPSStest.h */
/*
 * Copyright (c) 2017 National Institute of Informatics in Japan,
 * All rights reserved.
 *
 * This file or a portion of this file is licensed under the terms of
 * the NAREGI Public License, found at http://www.naregi.org/download/index.html.
 * If you redistribute this file, with or without modifications, you must
 * include this notice in the file.
 */

#ifndef SIGGENPSSTEST_H
#define SIGGENPSSTEST_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <aicrypto/ok_rsa.h>
#include <aicrypto/ok_asn1.h>
#include <aicrypto/ok_tool.h>

typedef struct mod1024 {
	uint8_t msg[128];
	uint8_t s[128];
	int sLen;
	uint8_t v[20];
} mod1024_t;

typedef struct mod1536 {
	uint8_t msg[128];
	uint8_t s[192];
	int sLen;
	uint8_t v[20];
} mod1536_t;

typedef struct mod4096 {
	uint8_t msg[128];
	uint8_t s[512];
	int sLen;
	uint8_t v[20];
} mod4096_t;

typedef struct mod2048 {
	uint8_t msg[128];
	uint8_t s[256];
	int sLen;
	uint8_t v[32];
} mod2048_t;

typedef struct mod3072 {
	uint8_t msg[128];
	uint8_t s[384];
	int sLen;
	uint8_t v[64];
} mod3072_t;
#endif /* SIGGENPSSTEST_H */
