#! /bin/sh
# -*- sh-shell: ash -*-

. ${srcdir}/test/test-common.sh

run_test() {
    echo "------------------------------------------------------------"
    echo "CLIENT CERTIFICATE AUTH"
    echo "------------------------------------------------------------"
    echo ""
    echo " * server: use store manager"
    echo " * server: use valid certificate"
    echo "           (sv1.example.org as id in store manager)"
    echo " * server: do NOT accept NULL client certificate."
    echo ""
    echo " * client: use store manager"
    echo " * client: use valid certificate that is issued by sub CA."
    echo "           (TEST USER4 as id in store manager)"
    echo ""

    run_server -a -s "${PATH_STM}" -i sv1.example.org

    if ! run_client -s "${PATH_STM}" -i 'TEST USER4'; then
	dump_output
	return ${F}
    fi

    dump_output
    return ${T}
}

main() {
    trap 'finish' 1 2 3 15

    # prepare test.
    prepare_test 8

    if ! run_test; then
	return ${F}
    fi

    return ${T};
}

main
